#################################################################
#     ___                       __                 _            #
#    /___\_ __  _   ___  __    / _\ ___ _ ____   _(_) ___ ___   #
#   //  // '_ \| | | \ \/ /    \ \ / _ \ '__\ \ / / |/ __/ _ \  #
#  / \_//| | | | |_| |>  <     _\ \  __/ |   \ V /| | (_|  __/  #
#  \___/ |_| |_|\__, /_/\_\    \__/\___|_|    \_/ |_|\___\___|  #
#               |___/                                           #
#                                                               #
#                                                               #
#                  Module: ms_onyx.inc                          #
#                  Auteur : ludo`                               #
#                  Site : www.zone-irc.com                      #
#                                                               #
#################################################################


#############################
#---------------------------#
# Configuration de MailServ #
#---------------------------#
#############################
## Activation de MailServ (0=dsactiv 1=activ)
set onyx(ms:global:active) "1"
## Pseudo de MailServ
set onyx(ms:pseudo) "MailServ"
## Identd de MailServ
set onyx(ms:ident) "mailserv"
## Realname de MailServ
set onyx(ms:real) "Bot de mail --> Onyx Service"
## Host de MailServ
set onyx(ms:host) "mail.domaine.tld"
## Mode de MailServ
set onyx(ms:mode) "+SBqW"
## Salon de MailServ
set onyx(ms:salon) "#Mail"
## Mode de MailServ sur le salon (q=owner a=protect o=op h=halfop v=voice)
set onyx(ms:mode_pseudo) "+o"
## Mode du salon de MailServ
set onyx(ms:mode_salon) "+ntsi"
######################
# Configuration mail #
######################
## Adresse de Sendmail
set onyx(ms:path) "/usr/sbin/sendmail"
## Email de l'expditeur
set onyx(ms:from) "MailServ@domaine.tld"
## Titre des Messages
set onyx(ms:titre) "Mini Email (Onyx Service)"
## Format du mail: (0=normal 1=html)   
set onyx(ms:format_mail) "1"
######################
# Configuration HTML #
######################
## Police d'ecriture
set onyx(ms:police) "Tahoma"
## Taille de l'ecriture
set onyx(ms:tpolice) "2"
## Taille du tableau
set onyx(ms:taille) "500"
## Couleur de fond
set onyx(ms:fond) "#F0F6FF"
## Couleur du Titre
set onyx(ms:tcouleur) "#ff0000"
## Couleur de l'ecriture
set onyx(ms:pcouleur) "#004f77"
## Couleur de fond du tableau
set onyx(ms:tfond) "#ffffff"
## Couleur de la bordure du tableau
set onyx(ms:bord) "#ff0000"

#############################################################################################################################

###############
# Fichiers db #
###############
proc ms:db {} {
  set nom_db "gestion.db"
  foreach nom_db2 $nom_db { 
    if {![file exists "db/ms_onyx/$nom_db2"]} { set ms_db [open db/ms_onyx/$nom_db2 a+]; close $ms_db }
  }
}

#############
# Lancement #
#############
proc ms:lancement {} {
  global onyx
  ## Gestion
  catch {open db/ms_onyx/gestion.db r} gestion_ms
  while {![eof $gestion_ms]} { 
    gets $gestion_ms var
    if {$var!=""} { set [lindex $var 0] [lrange $var 1 end] } 
  }
  catch {close $gestion_ms}
  ## Connextion
  if {$onyx(ms:global:active)=="1"} {
    putdcc $onyx(idx) ":$onyx(link) NICK $onyx(ms:pseudo) 1 [unixtime] $onyx(ms:ident) $onyx(ms:host) $onyx(link) :$onyx(ms:real)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:pseudo) $onyx(ms:mode)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) JOIN $onyx(ms:salon)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:salon) $onyx(ms:mode_pseudo) $onyx(ms:pseudo)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:salon) $onyx(ms:mode_salon)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) SQLINE $onyx(ms:pseudo) :Rserv  Onyx Service"
  }
  ############
  if {$onyx(ms:global:active)=="1"  && [string tolower $onyx(salon)]!=[string tolower $onyx(ms:salon)]} {
    putdcc $onyx(idx) ":$onyx(ms:pseudo) JOIN $onyx(salon)"
    putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(ms:pseudo)"
  }
}

##########
# Divers #
##########
proc ms:divers {arg} {
  global onyx
  set arg [join [split $arg]]
  set pour [lindex $arg 0]
  set idx2 [lindex $arg 1]
  if {$pour=="help"} { putdcc $idx2 "MailServ : 3.connexion_ms 14(connexion de $onyx(ms:pseudo)) 1| 4.deconnexion_ms 14(dconnexion de $onyx(ms:pseudo))" }
  if {$pour=="status"} {
    if {$onyx(ms:global:active)=="1"} { putdcc $idx2 "1MailServ (3Activ1) 3: 14Pseudo: $onyx(ms:pseudo) Salon: $onyx(ms:salon)" } else { putdcc $idx2 "1MailServ (4Dsactiv1) 3: 14Pseudo: $onyx(ms:pseudo) Salon: $onyx(ms:salon)" }
    if {$onyx(ms:format_mail)=="0"} { putdcc $idx2 "1MailServ 3: 14Format du mail: Normal Mail d'envoi: $onyx(ms:from)" } else { putdcc $idx2 "1MailServ 3: 14Format du mail: HTML Mail d'envoi: $onyx(ms:from)" }
  }
  if {$pour=="gestion"} {
    set sauv_ms [open db/ms_onyx/gestion.db w+]
    puts $sauv_ms "onyx(ms:global:active) $onyx(ms:global:active)"
    puts $sauv_ms "onyx(ms:pseudo) $onyx(ms:pseudo)"
    puts $sauv_ms "onyx(ms:ident) $onyx(ms:ident)"
    puts $sauv_ms "onyx(ms:host) $onyx(ms:host)"
    puts $sauv_ms "onyx(ms:real) $onyx(ms:real)"
    puts $sauv_ms "onyx(ms:salon) $onyx(ms:salon)"
    puts $sauv_ms "onyx(ms:format_mail) $onyx(ms:format_mail)"
    close $sauv_ms
  }
  if {$pour=="chanlog"} {
    if {$onyx(ms:global:active)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PART $onyx(salon) :Changement de salon" }
  }
}

###########
# ms:load #
###########
proc ms:load {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Chargement de $onyx(ms:pseudo) Bot de mail."
   ms:db
   ms:lancement
}

#############
# ms:unload #
#############
proc ms:unload {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Dchargement de $onyx(ms:pseudo)."
   putdcc $onyx(idx) ":$onyx(ms:pseudo) UNSQLINE $onyx(ms:pseudo)"
   putdcc $onyx(idx) ":$onyx(ms:pseudo) QUIT :Dcharg de Onyx Service."
}

###################
# ms:connexion_ms #
###################
bind dcc n connexion_ms ms:connexion_ms
proc ms:connexion_ms {nick idx arg} { 
   global onyx
   if {$onyx(ms:global:active)=="0"} { 
     putdcc $idx "Connexion de $onyx(ms:pseudo)"
     set onyx(ms:global:active) 1
     set onyx(os:host:[string tolower $onyx(ms:pseudo)]) $onyx(ms:host)
     putdcc $onyx(idx) ":$onyx(link) NICK $onyx(ms:pseudo) 1 [unixtime] $onyx(ms:ident) $onyx(ms:host) $onyx(link) :$onyx(ms:real)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:pseudo) $onyx(ms:mode)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) JOIN $onyx(ms:salon)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:salon) $onyx(ms:mode_pseudo) $onyx(ms:pseudo)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:salon) $onyx(ms:mode_salon)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) SQLINE $onyx(ms:pseudo) :Rserv  Onyx Service"
     if {[string tolower $onyx(salon)]!=[string tolower $onyx(ms:salon)]} {
       putdcc $onyx(idx) ":$onyx(ms:pseudo) JOIN $onyx(salon)"
       putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(ms:pseudo)"
     }
     onyx:gestion
   } else { putdcc $idx "$onyx(ms:pseudo) est dj connect..." }
}

#####################
# ms:deconnexion_ms #
#####################
bind dcc n deconnexion_ms ms:deconnexion_ms
proc ms:deconnexion_ms {nick idx arg} { 
   global onyx
   if {$onyx(ms:global:active)=="1"} { 
     putdcc $idx "Dconnexion de $onyx(ms:pseudo)"
     set onyx(ms:global:active) 0
     unset onyx(os:host:[string tolower $onyx(ms:pseudo)])
     putdcc $onyx(idx) ":$onyx(ms:pseudo) UNSQLINE $onyx(ms:pseudo)"
     putdcc $onyx(idx) ":$onyx(ms:pseudo) QUIT :$onyx(raison)"
     onyx:gestion 
     } else { putdcc $idx "$onyx(ms:pseudo) est dj dconnect..." }
}

###########
# ms:help #
###########
proc ms:help {arg} {
	global admin onyx
        set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set data [lindex $arg 3]
        set data2 [string tolower $data]
        set data3 [string tolower [lindex $arg 4]]
        if {$data2==""} {
         if {[info exists onyx(os:$vpseudo)] && [matchattr $onyx(os:$vpseudo) n]} {
         putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :SET Permet de configurer $onyx(ms:pseudo)."
         putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :MAIL Permet d'envoyer un mail."
         }
        } elseif {$data2=="set" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de voir la configuration possible de $onyx(ms:pseudo)."
        } elseif {$data2=="set" && $data3=="pseudo"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set pseudo nouveau_pseudo"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer le pseudo du bot."
        } elseif {$data2=="set" && $data3=="ident"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set ident nouveau_ident"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer l'ident du bot."
        } elseif {$data2=="set" && $data3=="host"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set host nouveau_host"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer l'host du bot."
        } elseif {$data2=="set" && $data3=="realname"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set realname nouveau_realname"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer le realname du bot."
        } elseif {$data2=="set" && $data3=="salon"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set salon #nouveau_salon"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer le salon principal du bot."
        } elseif {$data2=="set" && $data3=="format_mail"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set format_mail normal ou html"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de changer le format d'affichage du mail."
        } elseif {$data2=="set" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) set list"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet de montrer les fixatioms actuelles du bot."
        } elseif {$data2=="mail"} {
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Syntax: /msg $onyx(ms:pseudo) mail email message"
            putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Permet d'envoyer un mail."
        } else { putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :Aucune aide disponible sur cette commande." }
}

##########
# ms:set #
##########
proc ms:set {arg} {
	global onyx
	set arg [join [split $arg]]
	set pseudo [lindex $arg 0]
	set vpseudo [string tolower $pseudo]
	set data [string tolower [string trim [lindex $arg 3] :]]
	set data2 [lindex $arg 4]
	set vdata2 [string tolower $data2]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) n]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Votre  level est imsuffisant pour utilser cette commande."; return 0 }
	if {$data==""} { 
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :PSEUDO Permet de changer le pseudo du bot."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :IDENT Permet de changer l'ident du bot."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :HOST Permet de changer l'host du bot."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :REALNAME Permet de changer le realname du bot."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :SALON Permet de changer le salon principal du bot."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :FORMAT_MAIL Permet de changer le format d'affichage du mail."
          putdcc $onyx(idx) ":$onyx(ms:pseudo) Notice $pseudo :LIST Permet de montrer les fixatioms actuelles du bot."
          return 0 
	}
	if {$data=="pseudo"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set pseudo : /msg $onyx(ms:pseudo) set pseudo nouveau_pseudo"; return 0 }
          if {$vdata2==[string tolower $onyx(ms:pseudo)]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Pseudo Identique."; return 0 }
          set new_pseudo $data2
          set onyx(verif:pseudo_bot) "ms $new_pseudo $pseudo 0"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) WHO $new_pseudo"
        }
	if {$data=="ident"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set ident : /msg $onyx(ms:pseudo) set ident nouveau_ident"; return 0 }
          putdcc $onyx(idx) ":$onyx(ms:pseudo) CHGIDENT $onyx(ms:pseudo) $data2"
          set onyx(ms:ident) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Changement de l'ident russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set ident$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="host"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set host : /msg $onyx(ms:pseudo) set host nouveau_host"; return 0 }
          putdcc $onyx(idx) ":$onyx(ms:pseudo) CHGHOST $onyx(ms:pseudo) $data2"
          set onyx(os:host:[string tolower $onyx(ms:pseudo)]) $data2
          set onyx(ms:host) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Changement de l'host russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set host$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="realname"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set realname : /msg $onyx(ms:pseudo) set realname nouveau_realname"; return 0 }
          putdcc $onyx(idx) ":$onyx(ms:pseudo) CHGNAME $onyx(ms:pseudo) [lrange $arg 3 end]"
          set onyx(ms:real) [lrange $arg 3 end]
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Changement du realname russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set realname$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="salon"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set salon : /msg $onyx(ms:pseudo) set salon #nouveau_salon"; return 0 }
          if {[string index $data2 0]!="#"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Vous avez oublier le # devant le nouveau salon."; return 0 } 
          if {$vdata2==[string tolower $onyx(ms:salon)]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Salon Identique."; return 0 }
          putdcc $onyx(idx) ":$onyx(ms:pseudo) PART $onyx(ms:salon) :Changement de salon"
          set onyx(ms:salon) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(ms:pseudo) JOIN $onyx(ms:salon)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) MODE $onyx(ms:salon) $onyx(ms:mode_pseudo) $onyx(ms:pseudo)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Changement du salon russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set salon$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="format_mail"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set format_mail : /msg $onyx(ms:pseudo) set format_mail normal ou html."; return 0 }
          if {$data2=="normal"} { set onyx(ms:format_mail) 0 } elseif {$data2=="html"} { set onyx(ms:format_mail) 1 } else { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Set format_mail : /msg $onyx(ms:pseudo) set format_html normal ou html."; return 0 }
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Changement du format du mail russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set format_mail$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="list"} {
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Pseudo: $onyx(ms:pseudo)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Ident: $onyx(ms:ident)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Host: $onyx(ms:host)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Realname: $onyx(ms:real)"
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Salon: $onyx(ms:salon)"
          if {$onyx(ms:format_mail)=="0"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Format du mail: Normal" } else { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Format du mail: HTML" }
        }
}

##############
# Charfilter #
##############
proc ms:charfilter {word {nword ""} } {
	for {set i 0} {$i < [string length $word]} {incr i} {
	  switch -- [string index $word $i] {
	    "\"" {append nword "\\\""}
	    "\\" {append nword "\\\\"}
	    "\[" {append nword "\\\["}
	    "\]" {append nword "\\\]"}
	    "\}" {append nword "\\\}"}
	    "\{" {append nword "\\\{"}
	    default {append nword [string index $word $i]}
	  }
	}
	return $nword
}

###########
# ms:mail #
###########
proc ms:mail {arg} {
	global onyx
	set arg [join [split $arg]]
	set pseudo [lindex $arg 0]
	set vpseudo [string tolower $pseudo]
	set email [lindex $arg 3]
	set message [join [lrange $arg 4 end]]     
	if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) m]} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Votre  level est imsuffisant pour utilser cette commande."; return 0 }
	if {![string match *@* $email] || ![string match *.* $email] || $message==""} { putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $pseudo :Commande Mail : /msg $onyx(ms:pseudo) mail <email> <message>"; return 0 }
	set char [ms:charfilter $arg]
	set email [lindex $char 0]
	set message [join [lrange $char 1 end]]
	ms:envoimail "$pseudo $email [join $message]"
        if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(ms:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Mail$onyx(os:couleur_deco) :$onyx(os:couleur_txt) utilis par $pseudo" }
	return 0
}

################
# ms:envoimail #
################
proc ms:envoimail {arg} {
	global onyx sendmail envoi
        set arg [join [split $arg]]
	set envoi(mailer) [lindex $arg 0]
	set envoi(email) [lindex $arg 4]
	set envoi(message) [join [lrange $arg 5 end]]
        if {$onyx(ms:format_mail)=="0"} { 
          set sendmail(mail) [open "|$onyx(ms:path)" w]
	  puts $sendmail(mail) "To: $envoi(email)"
          puts $sendmail(mail) "From: $onyx(ms:pseudo) <$onyx(ms:from)>"
   	  puts $sendmail(mail) "Subject: $onyx(ms:titre)"
  	  puts $sendmail(mail) ""
   	  puts $sendmail(mail) "[join $envoi(message)]"
	  puts $sendmail(mail) ""
   	  puts $sendmail(mail) "Post par $envoi(mailer)"
   	  close $sendmail(mail)
          putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $envoi(mailer) :Votre Email a bien t transmit  $envoi(email)"
          unset envoi
          return 0
        }
        if {$onyx(ms:format_mail)=="1"} { 
	  set sendmail(mail) [open "|$onyx(ms:path)" w]
	  puts $sendmail(mail) "To: $envoi(email)"
  	  puts $sendmail(mail) "From: $onyx(ms:pseudo) <$onyx(ms:from)>"
   	  puts $sendmail(mail) "Subject: $onyx(ms:titre)"
	  puts $sendmail(mail) "MIME-Version: 1.0"
	  puts $sendmail(mail) "Content-type: text/html; charset=iso-8859-1"
	  puts $sendmail(mail) "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\"><html><head>"
	  puts $sendmail(mail) "<META content=\"MSHTML 6.00.2600.0\" name=GENERATOR></head>"
	  puts $sendmail(mail) "<body BGCOLOR=\"$onyx(ms:fond)\">"
  	  puts $sendmail(mail) "<br><br><center>"
	  puts $sendmail(mail) "<table style=\"border: 1px dotted $onyx(ms:bord)\" bgcolor=\"$onyx(ms:tfond)\" cellpadding=0 cellspacing=0 width=$onyx(ms:taille)>"
	  puts $sendmail(mail) "<tr>"
	  puts $sendmail(mail) "<td>"
	  puts $sendmail(mail) "<table width=\"100%\"><tr><td>&nbsp;</td><td width=\"100%\"><br>"
	  puts $sendmail(mail) "<center><font color=\"$onyx(ms:tcouleur)\" size=\"$onyx(ms:tpolice)\" face=\"$onyx(ms:police)\"><b>$onyx(ms:titre) par $onyx(ms:pseudo)</b></font></center><br>"
	  puts $sendmail(mail) "<font color=\"$onyx(ms:pcouleur)\" size=\"$onyx(ms:tpolice)\" face=\"$onyx(ms:police)\">[join $envoi(message)]<br><br>"
	  puts $sendmail(mail) "<div align=\"right\">$envoi(mailer)</div>"
	  puts $sendmail(mail) "</font><br>"
	  puts $sendmail(mail) "</td><td>&nbsp;</td>"
	  puts $sendmail(mail) "</tr>"
	  puts $sendmail(mail) "</table></td></tr></table></center><br><br>"
	  puts $sendmail(mail) "</body></html>"
   	  puts $sendmail(mail) ""
   	close $sendmail(mail)
	  putdcc $onyx(idx) ":$onyx(ms:pseudo) NOTICE $envoi(mailer) :Votre Email a bien t transmit  $envoi(email)"
	  unset envoi
          return 0
        }
}

############
# ms:event #
############
proc ms:event {arg} {
   global egg onyx admin
   set arg [join [split $arg]]
switch -exact [lindex $arg 1] {
  "PRIVMSG" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set commande [string tolower [string trim [lindex $arg 3] :]]
    set commande2 [string trim $commande $onyx(prefix)]
    set data [lrange $arg 3 end]
    if {$vpour==[string tolower $onyx(ms:pseudo)] || $vpour==[string tolower $onyx(ms:salon)]} { 
      if {[string tolower $onyx(ms:salon)]==$onyx(salon2) && $vpour!=[string tolower $onyx(ms:pseudo)]} { return 0 }
      if {$commande2=="help"} { if {[global:flood "ms $pseudo"]!="ok"} { return 0 }; ms:help "$pseudo $vpour $data" }
      if {$commande2=="set"} { if {[global:flood "ms $pseudo"]!="ok"} { return 0 }; ms:set "$pseudo $vpour $data" }
      if {$commande2=="mail"} { if {[global:flood "ms $pseudo"]!="ok"} { return 0 }; ms:mail "$pseudo $vpour $data" }
    }
    }
  "KILL" 
    { 
    set pseudo [lindex $arg 2]
    if {$pseudo==$onyx(ms:pseudo)} { ms:lancement }
    }
  }
}

##########
# ms:web #
##########
proc ms:web {arg} {
   global onyx 
   set htmlpage [lindex $arg 0]
   set num_menu [lindex $arg 1]
   puts $htmlpage "<table width=\"85%\" align=\"center\" id=\"menu$num_menu\" style=\"display: none; text-align: center\"><tr><td>"
   puts $htmlpage "<table width=\"100%\" align=\"center\"><tr>"
   puts $htmlpage "<td width=\"60%\" valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Pseudo du MailServ :</font> $onyx(ms:pseudo)<br>"
   puts $htmlpage "<font class=\"text1\">Ident du MailServ :</font> $onyx(ms:ident)<br>"
   puts $htmlpage "<font class=\"text1\">Host du MailServ :</font> $onyx(ms:host)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du MailServ :</font> $onyx(ms:mode)<br>"
   puts $htmlpage "<font class=\"text1\">Realname du MailServ :</font> $onyx(ms:real)<br>"
   puts $htmlpage "<font class=\"text1\">Salon du MailServ :</font> $onyx(ms:salon)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du salon :</font> $onyx(ms:mode_salon)<br>"
   puts $htmlpage "<font class=\"text1\">Mode sur le salon :</font> $onyx(ms:mode_pseudo)<br>"
   if {$onyx(ms:global:active)=="1"} { puts $htmlpage "<font class=\"text1\">MailServ activ :</font> Oui<br>" } else { puts $htmlpage "<font class=\"text1\">MailServ activ :</font> Non<br>" }
   puts $htmlpage "</td><td valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Expditeur :</font> $onyx(ms:from)<br>"
   puts $htmlpage "<font class=\"text1\">Objet :</font> $onyx(ms:titre)<br>"
   if {$onyx(ms:format_mail)=="1"} { puts $htmlpage "<font class=\"text1\">Format mail :</font> HTML<br>" } else { puts $htmlpage "<font class=\"text1\">Format mail :</font> Normal<br>" }
   puts $htmlpage "</td></tr></table><br>"
   puts $htmlpage "</td></tr></table>"   
}